apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ app_name }}-app
  namespace: {{env}}
  labels:
{% if matchlables is defined %}
{{matchlables|to_nice_yaml| indent(10,true)}}
{%- else %}
        app: {{ app_name}}-app
{% endif %}
spec:
  replicas: {{ replicaCount[env] }}
{% if updatestrategy[env] %}
  strategy:
    type: RollingUpdate
    rollingUpdate:
{{ updatestrategy[env] | to_nice_yaml | indent(6,true)}}
{%- endif %}
  selector:
    matchLabels:
{% if matchlables is defined %}
{{matchlables|to_nice_yaml| indent(10,true)}}
{%- else %}
        app: {{ app_name}}-app
{% endif %}
  template:
    metadata:
      labels:
{% if matchlables is defined %}
{{matchlables|to_nice_yaml| indent(10,true)}}
{%- else %}
  app: {{ app_name}}-app
{% endif %}
    spec:
      containers:
      - name: {{ app_name }}
        image: {{ imageUrl }}
        ports:
        - containerPort: {{ app.port }}
{% if livenessProbe is defined %}
        livenessProbe
{{livenessProbe | to_nice_yaml| indent(10,true)}}
{%- elif service.port is defined %}
        livenessProbe:
          httpGet:
            path: {{app.healthcheckpath}}
            port: {{app.port}}
          initialDelaySeconds: {{app.initialcheckdelay}}
          timeoutSeconds: {{app.healthchecktimeout}}
          successThreshold: 1
          failureThreshold: 2
          periodSeconds: 10
{% endif %}
{% if readinessProbe is defined %}
        readinessProbe
{{readinessProbe | to_nice_yaml| indent(10,true)}}
{% elif service.port is defined %}
        readinessProbe:
          httpGet:
            path: {{app.healthcheckpath}}
            port: {{app.port}}
          initialDelaySeconds: {{app.initialcheckdelay}}
          timeoutSeconds: {{app.healthchecktimeout}}
          successThreshold: 2
          failureThreshold: 2
          periodSeconds: 10
{% endif %}
        resources:
         requests:
           memory: "{{resources.req_mem | default(500)}}Mi"
           cpu: "{{resources.req_cpu | default(500)}}m"
         limits:
           memory: "{{resources.limit_mem | default(500)}}Mi"
           cpu: "{{resources.limit_cpu | default(500)}}m"
{% if nodeselector is defined %}
        nodeSelector:
{{nodeselector | to_nice_yaml| indent(10,true)}}
{%- endif %}
